/* PK2 WiFi Scan
 * Faz a varredura das redes WiFi recebidas.
 * Mostra o SSID - identificação da rede (esta informação será usada nos experimentos)
 * Monstra a RSSI - intensidade do sinal de rádio recebida pelo NodeMCU
*/
#include "ESP8266WiFi.h"

void setup() {
  Serial.begin(115200);
  pinMode(D3, OUTPUT); // LED vermelho
  pinMode(D4, OUTPUT); // LED verde
  pinMode(D7, OUTPUT); // LED amarelo
  pinMode(D5, OUTPUT); // Buzzer
  // Coloca no modo WiFi Station (WiFi_STA)
  WiFi.mode(WIFI_STA);
  // Desconecta de um AP que estava previamente conectado para poder fazer o WiFi Scan
  WiFi.disconnect();
  delay(100);
  Serial.println("Setup done");
}

void loop() {
  Serial.println("INF505 - PK2 - varredura de redes WiFi existentes");
   digitalWrite (D3, LOW); // apaga LED vermelho
  // Retorna número de redes encontradas
  int n = WiFi.scanNetworks();
  //Serial.println("Varredura realizada");
  if (n == 0) {
    Serial.println(" Não foi encontrada nenhuma rede");
  } else {

    Serial.print("Redes WiFi encontradas = ");
    Serial.println(n);
    for (int i = 0; i < n; ++i) {
// Apresenta no serial monitor o SSID e a RSSI de cada rede encontrada
      Serial.print(i + 1);
      Serial.print(" - SSID: ");
      Serial.print(WiFi.SSID(i)); 
      Serial.print("  -  RSSI = ");
      Serial.print(WiFi.RSSI(i));
      Serial.print("  (dBm) ");
      Serial.println("");
      delay(10);
 
 // Pisca LEDs e toca buzzer quando termina o WiFi Scan
      digitalWrite(D3, LOW);
      delay(50);        
      digitalWrite(D3, HIGH);     

      digitalWrite(D4, HIGH);
      delay(50);        
      digitalWrite(D4, LOW);  

      digitalWrite(D7, LOW);
      delay(50);        
      digitalWrite(D7, HIGH);     

// Buzzer
      digitalWrite(D5, HIGH);
      delay(50);        
      digitalWrite(D5, LOW);     
    }
  }
  Serial.println("");

  // Aguarda 4 segundos para a próxima varredura
  delay(4000);
}
