import serial
import time
from tkinter import *
import tkinter.scrolledtext as ScrolledText
import tkinter.ttk as ttk
import tkinter.filedialog
import tkinter.messagebox as tkMessageBox
import matplotlib
matplotlib.use('TkAgg')
import serial.tools.list_ports
import platform
 
 #Saída: 'Linux'


#VARIAVEIS GLOBAIS
#s1 = arquivo de log (.csv)
#ser = porta serial
#exe = objeto thread, que serve para iniciar ou parar a execução de uma função
global ser

 

#funcao que verifica as portas seriais ativas no pc
def verificar_portas():
    portas_ativas = []
    for n in range(100):
        try:
            ver=serial.Serial("COM"+str(n))
            portas_ativas.append(ver.portstr)
            ver.close()
        except serial.SerialException:
            pass
    return portas_ativas


#funcao que atualiza as portas seriais ativas no pc
def atualizar_portas():
    portas_ativas = []
    for n in range(100):
        try:
            ver=serial.Serial("COM"+str(n))
            portas_ativas.append(ver.portstr)
            ver.close()
        except serial.SerialException:
            pass
    print(portas_ativas)
    portas['values']= portas_ativas

    
# função que é executada ao clicar no botão "fechar (X)" da aplicação
def callback():
    global ser
    if tkMessageBox.askokcancel("Sair", "Tem certeza que deseja sair?"):

        try:
            ser.close()

        except Exception as e:
            print("ok")
        raiz.destroy()

#funcao que envia um pacote de teste para verificar o estado da conexão serial
def testar():
    global ser
    try:
            
        Pacote = {}

        # Configura a serial
        print(platform.system())
        so=platform.system()
        if(so=="Windows"):
            print("entrou")
            ser = serial.Serial(portas.get(), 115200, timeout=0.5) # seta valores da serial    
        elif(so=="Linux"):
            print("linux")
            ser = serial.Serial('/dev/ttyUSB0', 115200, timeout=1)
        else:
            print("mac")
            serial.Serial('/dev/cu.usbserial-0001', 115200, timeout=1)
            
            
        time.sleep(2)

        # Identificação do sensor a ser acessado
        #print 'ID_sensor:'
        ID_sensor = 1

        # Identificação da base
        #print 'ID_base:'
        ID_base = 0

        # Cria Pacote de 52 bytes com valor zero em todas as posições
        for i in range(0,52): # faz um array com 52 bytes
           Pacote[i] = 0

              # Limpa o buffer da serial
        ser.flushInput()

              # Coloca no pacote o ID_sensor e ID_base
        Pacote[8] = ID_sensor #origem
        Pacote[10] = ID_base #destino
        Pacote[16] = 16
        Pacote[17] = 17
        Pacote[18] = 18
               
        conteudo_tx.config(state="normal")
        conteudo_tx.insert(END, "Pacote Enviado: "+"\n"+str(Pacote))
        
        for i in range(0,52):
           TXbyte = chr(Pacote[i]) # Deve converter para caracter em ASCII para escrever na serial
           ser.write(TXbyte.encode('latin1'))

              # Tempo de espera para que receba a resposta do sensor
        time.sleep(0.5)

              # RX pacote - recebe o pacote enviado pelo sensor
        line = ser.read(52) # faz a leitura de 52 bytes do buffer que recebe da serial pela COM
        # Checa se recebeu 52 bytes 
        if len(line) == 52:
           conteudo_rx.config(state="normal")
           conteudo_rx.insert(END, "Pacote Recebido: "+"\n"+str(Pacote))
           tkMessageBox.showinfo(message="Porta "+ portas.get()+ " conectada!\n Teste Concluído com sucesso!")  
           btn_teste.config(state="disable")
           
        else:           
           tkMessageBox.showinfo(message="Porta "+ portas.get() + " NÃO conectada! Teste falhou!")
           time.sleep(0.3)
           ser.flushInput()

        
    except Exception as erro:
        tkMessageBox.showinfo(message=erro)


#####----------------------------------------CRIAÇAO DA JENLA PRINCIPAL E FRAMES---------------------

raiz=Tk() #criando a tela principal , usando um objeto TKinter
raiz.title("Laboratório IoT Oficina - Teste de conexão Python") #funcao para alterar titulo da janela
raiz.geometry('1000x200') #define o tamanho da janela
raiz.resizable(0, 0) #deixa o tamanho da janela fixo, sem opções de redimensionamento

frame_cima = Frame(master=raiz,borderwidth=1, relief='sunken') #cria um frame no topo da janela, define como master a janela principal(raiz)
frame_cima.place(x=10,y=10,width=980,height=180) #posiciona e define o tamanho dos frames

####----------------------------------------------TESTE----------------------------------------

label_dados=Label(master=frame_cima, font=("Arial", 10, "bold"),text = "Computador envia pacote para NodeMCU") #define um label (texto estático)
label_dados.place(x=330,y=1) #posiciona o label usando "place"

label_dados=Label(master=frame_cima, font=("Arial", 10, "bold"),text = "Computador recebe pacote do NodeMCU") #define um label (texto estático)
label_dados.place(x=680,y=1) #posiciona o label usando "place"

btn_teste=Button(frame_cima,text="Conectar",command=testar, width=8) #define um botão
btn_teste.place(x=20,y=25) #posiciona o botão usando "place"

portas = ttk.Combobox(frame_cima,width=15)
portas.place(x=130,y=25)
portas['values']= verificar_portas()

btn_atual=Button(frame_cima,text="Atualizar Portas",command=atualizar_portas, width=14)
btn_atual.place(x=132,y=60)

conteudo_tx= tkinter.scrolledtext.ScrolledText(frame_cima,width=35,height=8,padx=5,pady=5)
conteudo_tx.config(state="disabled")
conteudo_tx.place(x=320, y= 30)

conteudo_rx= tkinter.scrolledtext.ScrolledText(frame_cima,width=35,height=8,padx=5,pady=5)
conteudo_rx.config(state="disabled")
conteudo_rx.place(x=660, y= 30)

raiz.protocol("WM_DELETE_WINDOW", callback)
raiz.mainloop()

